[dpdk-ci] [PATCH v5 2/9] tools: add mail parser

Thomas Monjalon thomas.monjalon at 6wind.com
Thu Dec 15 00:05:16 CET 2016


This script get some mail headers from an email file.
The retrieved headers can be used for test and report in other scripts.

Signed-off-by: Thomas Monjalon <thomas.monjalon at 6wind.com>
---
 tools/parse-email.sh | 72 ++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 72 insertions(+)
 create mode 100755 tools/parse-email.sh

diff --git a/tools/parse-email.sh b/tools/parse-email.sh
new file mode 100755
index 0000000..d92c246
--- /dev/null
+++ b/tools/parse-email.sh
@@ -0,0 +1,72 @@
+#! /bin/sh -e
+
+# BSD LICENSE
+#
+# Copyright 2016 6WIND S.A.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+#   * Redistributions of source code must retain the above copyright
+#     notice, this list of conditions and the following disclaimer.
+#   * Redistributions in binary form must reproduce the above copyright
+#     notice, this list of conditions and the following disclaimer in
+#     the documentation and/or other materials provided with the
+#     distribution.
+#   * Neither the name of 6WIND S.A. nor the names of its
+#     contributors may be used to endorse or promote products derived
+#     from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+print_usage () {
+	cat <<- END_OF_HELP
+	usage: $(basename $0) <email_file>
+
+	Parse basic headers of the email
+	and print them as shell variable assignments to evaluate.
+	END_OF_HELP
+}
+
+while getopts h arg ; do
+	case $arg in
+		h ) print_usage ; exit 0 ;;
+		? ) print_usage >&2 ; exit 1 ;;
+	esac
+done
+shift $(($OPTIND - 1))
+if [ -z "$1" ] ; then
+	printf 'file argument is missing\n\n' >&2
+	print_usage >&2
+	exit 1
+fi
+
+getheader () # <header_name> <email_file>
+{
+	sed "/^$1: */!d;s///;N;s,\n[[:space:]]\+, ,;s,\n.*,,;q" "$2" |
+	sed 's,",\\",g'
+}
+
+subject=$(getheader Subject "$1")
+from=$(getheader From "$1")
+msgid=$(getheader Message-Id "$1")
+[ -n "$msgid" ] || msgid=$(getheader Message-ID "$1")
+listid=$(getheader List-Id "$1")
+
+cat <<- END_OF_HEADERS
+	subject="$subject"
+	from="$from"
+	msgid="$msgid"
+	listid="$listid"
+END_OF_HEADERS
-- 
2.7.0



More information about the ci mailing list